## function based on cleversearch(svcm)
## modifications:
## - to be used only with a grid on logarithmic scale
## - updated starting values at each iteration from the previous estimation
cleversearchSTART <- function (fn, lower,
                               upper, ngrid, 
                               coef.st,
                               startvalue){
  ndims <- length(lower)
  grid <- NULL
  for(i in 1:ndims) {
    grid <- cbind(grid, 10^seq(lower[i], upper[i], length = ngrid))
  }
  fmin <- Inf
  fn1 <- function(pnew, coef.st) fn(pnew, coef.st)

  if (missing(startvalue)) {
    if (ndims == 1) {
      index <- 1
    }
    else {
      index <- floor(ngrid/2) * rep(1, ndims)
    }
  }
  else {
    index <- NULL
    for (i in 1:ndims) {
      tmp <- max(which(order(c(startvalue[i], grid[,i])) == 1) - 1, 1)
      index <- c(index, tmp)
    }
  }
  
  par <- rep(0, ndims)
  for (i in 1:ndims) {
    par[i] <- grid[index[i], i]
  }

  lookup <- array(NA, rep(ngrid, ndims))
  
  move <- 1
  nstep <- 0
  while(move){
    move <- 0
    for(i in 1:ndims){
      lookupi <- index
      for(j in (index[i] - 1):(index[i] + 1)){
        j <- max(min(j, ngrid), 1)
        lookupi[i] <- j
        if(is.na(lookup[t(lookupi)])){
          pnew <- par
          pnew[i] <- grid[j, i]
          fnew <- fn1(pnew, coef.st)
          lookup[t(lookupi)] <- fnew$BIC
          coef.st <- fnew$COEF
          nstep <- nstep + 1
        }
        else{
          fnew$BIC <- lookup[t(lookupi)]
        }
        if(fnew$BIC < fmin){
          fmin <- fnew$BIC
          index[i] <- j
          par <- pnew
          move <- move + 1
        }
      }
    }
  }
  return(list(par = par, value = fmin, counts = nstep))
}
